Subject: bug#16495: problems emacs emacs 24.3.50 with mumamo and nxhtml modes

From: Jonathan Payne <[email-masked]>
Date: Sun, 19 Jan 2014 16:08:30 +0000

Here are some issues I have had editing Django templates using MuMaMo nXhtml/django-nxhtml mode. This works fine in emacs 24.3.1.

1) When first loading a file a jit-lock issue causes an exception and we end up NOT in html mode:

> ad-handle-definition: `rng-validate-mode' got redefined
> Loading nxhtml-mode...done
> File mode specification error: (wrong-type-argument timerp [t nil nil nil nil nil nil nil])
> Error running timer `jit-lock-stealth-fontify': (wrong-type-argument timerp [t nil nil nil nil nil nil nil]) [4 times]

if I revisit the same file I end up in "MuMaMo border/django-nxhtml" mode, and the buffer is properly fontified. But I still get errors about jit-lick-stealth-fontify. Also these are appearing in *Compile-Log* but I am not sure why because I just loaded a file, not tried to compile emacs lisp files:

> Warning: `comment-use-global-state' is an obsolete variable (as of 24.4); use
> `comment-use-syntax' instead.

2) In the html file in a CSS section, I pressed C-o to do "open-line" and the line was opened but the cursor moved down a line as though I had pressed Return to insert a line. There's a new set of emacs errors that occurred including one which might explain why open-line failed:

> Error running timer `jit-lock-stealth-fontify': (wrong-type-argument timerp [t nil nil nil nil nil nil nil]) [2 times]
> ESC C-M-p is undefined
> Beginning of buffer [7 times]
> Mark set
> Error running timer `jit-lock-stealth-fontify': (wrong-type-argument timerp [t nil nil nil nil nil nil nil])
> Using vacuous schema
> Using schema /Applications/My Applications/Emacs (save).app/Contents/Resources/etc/schema/xhtml.rnc
> Internal error in rng-validate-mode triggered at buffer position 165. Symbol's function definition is void: rng-mark-xmltok-dependent-regions
> self-insert-command: Wrong number of arguments: (2 . 2), 3

Meanwhile, performing "open-line" inside a bit of HTML section works as expected.

3) Stepping *with Control-N" into a JavaScript section of the file produced more jit-lock errors with timerp as described above. More of these as well:

> Internal error in rng-validate-mode triggered at buffer position 7417. Symbol's function definition is void: rng-mark-xmltok-dependent-regions
> self-insert-command: Wrong number of arguments: (2 . 2), 3

4) I had issues indenting code in JavaScript. It gets some things wrong which it didn't used to get wrong. AND sometimes (but this is intermittent which makes no sense to me) it displays an error when I try to indent some lines. It's possible it was just the jit-lock-stealth-fontify bug, which happens in the background periodically ... but I think ... Wait - here it is. If I reload the file and then go straight into some JavaScript code and press tab to indent I get this:

> Using schema /Applications/My Applications/Emacs (save).app/Contents/Resources/etc/schema/xhtml.rnc
> Internal error in rng-validate-mode triggered at buffer position 165. Symbol's function definition is void: rng-mark-xmltok-dependent-regions
> mumamo-indent-line-in-mirror: Wrong number of arguments: (2 . 2), 3